#include <string.h>

#define SEG_A 13
#define SEG_B 12
#define SEG_C 11
#define SEG_D 10
#define SEG_E 9
#define SEG_F 8
#define SEG_G 7

char segments[] = {'a','b','c','d','e','f','g'};

char number1[] = {'b','c',0};
char number2[] = {'a', 'b','g','e','d',0};
char number3[] = {'a', 'b', 'c', 'd', 'g',0};
char number4[] = {'f','g','b','c',0};
char number5[] = {'a','f','g','c','d',0};
char number6[] = {'a','c','d','e','f','g',0};
char number7[] = {'a','b','c',0};
char number8[] = {'a','b','c','d','e','f','g',0}; // Sama kuin segments[]
char number9[] = {'a','b','g','f','c','d',0};
char zero[] = {'a','b','c','d','e','f',0};

char *numbersArray[] = {zero,number1,number2,number3,number4,number5,number6,number7,number8,number9,0};

void setup() {
  pinMode(SEG_A, OUTPUT);
  pinMode(SEG_B, OUTPUT);
  pinMode(SEG_C, OUTPUT);
  pinMode(SEG_D, OUTPUT);
  pinMode(SEG_E, OUTPUT);
  pinMode(SEG_F, OUTPUT);
  pinMode(SEG_G, OUTPUT);
  
  Serial.begin(115200);
}
int segNum = 1;
char segChar = 'a';
void loop() 
{
    // Laitetaan yksittäinen segmentti päälle
    for(segChar = 'a'; segChar < 'h'; segChar++)
    {
      SetSegment(segChar, true);
      delay(100);
      SetSegment(segChar, false);
    }
  delay (1000);
  
  for(segNum = 0; segNum < 10; segNum++)
  {  
    SetNumber(segNum);
    delay (1000);
  }
  delay(1000);
}
void AllSegmentsOff()
{
  int index = 0;
  for( index = 0 ; index < 7; index++)
   {
       SetSegment(segments[index],false);            
   }
}
void SetNumber(int num)
{
  int temp = 0;
  int count = 0;
  char *array;
  
  AllSegmentsOff();
  
  if( (num > 9) || (num < 0))
  {
    // Jos numero on lukualueen yli niin sitä ei voi näyttää
    Serial.println("Over the Range!");
    return;
  }
  
  Serial.println(num,DEC);

  /*
  for(temp = 0; temp < 10; temp++)
  {
    Serial.println(numbersArray[num]);
  }
*/
  array = numbersArray[num];
  
  Serial.println(array);
  // tutkitaan mikä on taulukon pituus
  while(array[count++] != 0);
  Serial.println(count,DEC);
  
  while(count--)
  {
    SetSegment( array[count],true);
  }
}
void SetSegment(char segment, bool onOff)
{
switch(segment)
{
  case 'A':
  case 'a':
  if(onOff == true)
  {
    digitalWrite(SEG_A,HIGH);
  }
  else
  {
    digitalWrite(SEG_A,LOW);
  }
  break;
  
  case 'B':
  case 'b':
  if(onOff == true)
  {
    digitalWrite(SEG_B,HIGH);
  }
  else
  {
    digitalWrite(SEG_B,LOW);
  }
  break;
  
  case 'C':
  case 'c':
    if(onOff == true)
  {
    digitalWrite(SEG_C,HIGH);
  }
  else
  {
    digitalWrite(SEG_C,LOW);
  }
  break;
  
  case 'D':
  case 'd':
    if(onOff == true)
  {
    digitalWrite(SEG_D,HIGH);
  }
  else
  {
    digitalWrite(SEG_D,LOW);
  }
  break;
  
  case 'E':
  case 'e':
    if(onOff == true)
  {
    digitalWrite(SEG_E,HIGH);
  }
  else
  {
    digitalWrite(SEG_E,LOW);
  }
  break;
  
  case 'F':
  case 'f':
    if(onOff == true)
  {
    digitalWrite(SEG_F,HIGH);
  }
  else
  {
    digitalWrite(SEG_F,LOW);
  }
  break;
  
  case 'G':
  case 'g':
    if(onOff == true)
  {
    digitalWrite(SEG_G,HIGH);
  }
  else
  {
    digitalWrite(SEG_G,LOW);
  }
  break;
  default:
    // Do nothing
  break;
} // switch end 
  
}
